//
// This file is auto-generated by generate.py. Do not modify this file directly.
//

//
// Core minimizations
//
out << std::endl;
out << "### Core minimizations" << std::endl;
out << std::endl;

out << "--minimize, --no-minimize (default: on)" << std::endl;
out << "Minimize found cores" << std::endl << std::endl;

out << "--limit-minimize (default: INT_MAX)" << std::endl;
out << "int: [2 .. INT_MAX]" << std::endl;
out << "Only attempt to minimize cores smaller than this" << std::endl << std::endl;

out << "--min-prop-limit (default: 0)" << std::endl;
out << "int: [0 .. INT_MAX]" << std::endl;
out << "Propagation limit for minimization calls (0 = no limit)" << std::endl << std::endl;

out << "--min-conf-limit (default: 0)" << std::endl;
out << "int: [0 .. INT_MAX]" << std::endl;
out << "Conflict limit for minimization calls (0 = no limit)" << std::endl << std::endl;

out << "--minimize-algorithm (default: \"destructive\")" << std::endl;
out << "std::string: {\"destructive\",\"constructive\",\"binarysearch\",\"cardinality\",\"rerefute\"}" << std::endl;
out << "Core minimization algorithm" << std::endl << std::endl;

out << "--separate-muser, --no-separate-muser (default: on)" << std::endl;
out << "Use a separate instance of Minisat to minimize cores" << std::endl << std::endl;

out << "--rerefute, --no-rerefute (default: on)" << std::endl;
out << "Re-refute found cores (subsumed by minimization)" << std::endl << std::endl;

//
// Non-optimal hitting sets
//
out << std::endl;
out << "### Non-optimal hitting sets" << std::endl;
out << std::endl;

out << "--nonopt (default: \"disjoint+greedy\")" << std::endl;
out << "std::string: {\"none\",\"disjoint\",\"common\",\"frac\",\"greedy\",\"disjoint+greedy\",\"common+greedy\",\"frac+greedy\"}" << std::endl;
out << "Strategy to use for minimum cost hitting set approximations\n\
common: add the variable with the most occurrences in cores so far\n\
frac: like common but add some fraction of the most occurring variables to the hitting set\n\
disjoint: add entire core to hitting set. Finds disjoint set of cores between optimal hitting sets (equivalent to --nonopt frac --frac-size 1.0)\n\
[strategy]+greedy: use greedy algorithm as fallback for another strategy" << std::endl << std::endl;

out << "--lp-nonopt, --no-lp-nonopt (default: off)" << std::endl;
out << "Use LP relaxation of MCHS IP for non-optimal hitting sets" << std::endl << std::endl;

out << "--limit-nonopt (default: INT_MAX)" << std::endl;
out << "int: [1 .. INT_MAX]" << std::endl;
out << "Limit for cores found in non-optimal phase" << std::endl << std::endl;

out << "--frac-size (default: 0.1)" << std::endl;
out << "double: (0 .. 1]" << std::endl;
out << "When using \"--nonopt frac\", the fraction of a new core to add to the hitting set" << std::endl << std::endl;

//
// Preprocessing & Label-MaxSAT
//
out << std::endl;
out << "### Preprocessing & Label-MaxSAT" << std::endl;
out << std::endl;

out << "--preprocess, --no-preprocess (default: on)" << std::endl;
out << "Enable SAT-based preprocessing with MaxPre" << std::endl << std::endl;

out << "--pre-only, --no-pre-only (default: off)" << std::endl;
out << "Only output the preprocessed formula (do not solve)" << std::endl << std::endl;

out << "--pre-techniques (default: \"[bu]#[buvsrgc]\")" << std::endl;
out << "std::string: " << std::endl;
out << "Preprocessing techniques to use (See MaxPre documentation)" << std::endl << std::endl;

out << "--infile-assumptions, --no-infile-assumptions (default: off)" << std::endl;
out << "LCNF: get assumption variables and polarities from \"c assumptions ...\" line in input" << std::endl << std::endl;

//
// Solution enumeration
//
out << std::endl;
out << "### Solution enumeration" << std::endl;
out << std::endl;

out << "--enumerate, --no-enumerate (default: off)" << std::endl;
out << "Incrementally enumerate multiple MaxSAT solutions" << std::endl << std::endl;

out << "--enum-type (default: 1)" << std::endl;
out << "int: {1,2,-1,-2}" << std::endl;
out << "1: only enumerate optimal solutions\n\
2: also report best sub-optimal solutions\n\
-1, -2: same as above, but enumerate only solutions with unique sets of satisfied clauses" << std::endl << std::endl;

out << "--enum-limit (default: INT_MAX)" << std::endl;
out << "int: [1 .. INT_MAX]" << std::endl;
out << "Maximum number of solutions to enumerate" << std::endl << std::endl;

//
// CPLEX parameters
//
out << std::endl;
out << "### CPLEX parameters" << std::endl;
out << std::endl;

out << "--mip-threads (default: 1)" << std::endl;
out << "int: [0 .. INT_MAX]" << std::endl;
out << "CPLEX Threads" << std::endl << std::endl;

out << "--mip-intensity (default: 2)" << std::endl;
out << "int: [0 .. 4]" << std::endl;
out << "CPLEX SolnPoolIntensity" << std::endl << std::endl;

out << "--mip-replace (default: 2)" << std::endl;
out << "int: [0 .. 2]" << std::endl;
out << "CPLEX SolnPoolReplace" << std::endl << std::endl;

out << "--mip-capacity (default: 10)" << std::endl;
out << "int: [0 .. INT_MAX]" << std::endl;
out << "CPLEX SolnPoolCapacity" << std::endl << std::endl;

out << "--mip-poplim (default: 100)" << std::endl;
out << "int: [0 .. INT_MAX]" << std::endl;
out << "CPLEX PopulateLim" << std::endl << std::endl;

out << "--mip-start (default: 2)" << std::endl;
out << "int: [0 .. 2]" << std::endl;
out << "CPLEX AdvInd" << std::endl << std::endl;

out << "--mip-emph (default: 0)" << std::endl;
out << "int: [0 .. 4]" << std::endl;
out << "CPLEX MIPEmphasis" << std::endl << std::endl;

out << "--mip-export-model (default: \"\")" << std::endl;
out << "std::string: matches /\":.*\\.(?:(?:lp)|(?:sav)|(?:mps))$\"/" << std::endl;
out << "The .lp .sav or .mps filename to writeIP model to" << std::endl << std::endl;

//
// Minisat parameters
//
out << std::endl;
out << "### Minisat parameters" << std::endl;
out << std::endl;

out << "--sat-polarity (default: 0)" << std::endl;
out << "int: {-1,0,1}" << std::endl;
out << "Set the Minisat variable polarity to control branching (-1=false, 0=undefined, 1=true)" << std::endl << std::endl;

out << "--sat-var-decay (default: 0.95)" << std::endl;
out << "double: (0 .. 1)" << std::endl;
out << "Minisat: Variable activity decay factor" << std::endl << std::endl;

out << "--sat-cla-decay (default: 0.999)" << std::endl;
out << "double: (0 .. 1)" << std::endl;
out << "Minisat: Clause activity decay factor" << std::endl << std::endl;

out << "--sat-rnd-freq (default: 0)" << std::endl;
out << "double: [0 .. 1]" << std::endl;
out << "Minisat: The frequency with which the decision heuristic tries to choose a random variable" << std::endl << std::endl;

out << "--sat-rnd-seed (default: 91648253)" << std::endl;
out << "double: [0 .. DBL_MAX)" << std::endl;
out << "Minisat: Pseudorandom generator seed value" << std::endl << std::endl;

out << "--sat-gc-frac (default: 0.2)" << std::endl;
out << "double: (0 .. DBL_MAX)" << std::endl;
out << "Minisat: The fraction of wasted memory allowed before a garbage collection is triggered" << std::endl << std::endl;

out << "--sat-cc-min-mode (default: 2)" << std::endl;
out << "int: {0,1,2}" << std::endl;
out << "Minisat: Controls conflict clause minimization in (0=none, 1=basic, 2=deep)" << std::endl << std::endl;

out << "--sat-phase-saving (default: 2)" << std::endl;
out << "int: {0,1,2}" << std::endl;
out << "Minisat: Controls the level of phase saving in (0=none, 1=limited, 2=full)" << std::endl << std::endl;

out << "--sat-rnd-init-act, --no-sat-rnd-init-act (default: off)" << std::endl;
out << "Minisat: Randomize initial activity" << std::endl << std::endl;

out << "--sat-luby, --no-sat-luby (default: on)" << std::endl;
out << "Minisat: Use the Luby restart sequence" << std::endl << std::endl;

out << "--sat-restart-first (default: 100)" << std::endl;
out << "int: [1 .. INT_MAX]" << std::endl;
out << "Minisat: The base restart interval" << std::endl << std::endl;

out << "--sat-restart-inc (default: 2)" << std::endl;
out << "double: [1 .. DBL_MAX)" << std::endl;
out << "Minisat: Restart interval increase factor" << std::endl << std::endl;

out << "--sat-learntsize-factor (default: 0.33333)" << std::endl;
out << "double: (0 .. 100]" << std::endl;
out << "Minisat: Limit on number of learnt clauses as a fraction of original clauses" << std::endl << std::endl;

out << "--sat-learntsize-inc (default: 1.1)" << std::endl;
out << "double: (0 .. 100]" << std::endl;
out << "Minisat: Rate at which learntsize-factor increases between restarts" << std::endl << std::endl;

//
// Assumption shuffle
//
out << std::endl;
out << "### Assumption shuffle" << std::endl;
out << std::endl;

out << "--shuffle, --no-shuffle (default: on)" << std::endl;
out << "Re-run Minisat's analyzeFinal with shuffled assumption orderings to find different cores" << std::endl << std::endl;

out << "--limit-shuffle (default: 19)" << std::endl;
out << "int: [1 .. INT_MAX]" << std::endl;
out << "Number of shuffled orderings to try" << std::endl << std::endl;

out << "--shuffle-disjoint, --no-shuffle-disjoint (default: on)" << std::endl;
out << "Only get a disjoint set of cores from shuffle" << std::endl << std::endl;

out << "--shuffle-core-limit (default: INT_MAX)" << std::endl;
out << "int: [1 .. INT_MAX]" << std::endl;
out << "Limit number of cores found per SAT call" << std::endl << std::endl;

//
// CPLEX callbacks
//
out << std::endl;
out << "### CPLEX callbacks" << std::endl;
out << std::endl;

out << "--cplex-lb-cutoff, --no-cplex-lb-cutoff (default: on)" << std::endl;
out << "Cutoff CPLEX at previous LB" << std::endl << std::endl;

out << "--cplex-ub-cutoff, --no-cplex-ub-cutoff (default: off)" << std::endl;
out << "Cutoff CPLEX when UB is improved if no new cores were found" << std::endl << std::endl;

out << "--cplex-reducedcosts, --no-cplex-reducedcosts (default: on)" << std::endl;
out << "Use reduced costs to harden or relax variables in IP." << std::endl << std::endl;

//
// Presolve
//
out << std::endl;
out << "### Presolve" << std::endl;
out << std::endl;

out << "--disjoint-pre, --no-disjoint-pre (default: on)" << std::endl;
out << "Find disjoint set of cores before main IHS loop" << std::endl << std::endl;

out << "--equiv-seed, --no-equiv-seed (default: on)" << std::endl;
out << "Seed CPLEX with blocking variable equivalences" << std::endl << std::endl;

//
// Misc
//
out << std::endl;
out << "### Misc" << std::endl;
out << std::endl;

out << "--ip, --no-ip (default: off)" << std::endl;
out << "Solve the instance using CPLEX and a standard IP encoding of MaxSAT" << std::endl << std::endl;

out << "--reset, --no-reset (default: on)" << std::endl;
out << "Clear learnt clauses between refutations and re-refutations" << std::endl << std::endl;

out << "--invert, --no-invert (default: on)" << std::endl;
out << "Invert variable activity between refutations and re-refutations" << std::endl << std::endl;

out << "--random-seed (default: 9)" << std::endl;
out << "int: [0 .. INT_MAX]" << std::endl;
out << "Seeds random number generator for LMHS" << std::endl << std::endl;

out << "--incomplete, --no-incomplete (default: off)" << std::endl;
out << "Print best found solution on SIGTERM" << std::endl << std::endl;

//
// Debug and output
//
out << std::endl;
out << "### Debug and output" << std::endl;
out << std::endl;

out << "--help, --no-help (default: off)" << std::endl;
out << "Print help text" << std::endl << std::endl;

out << "--print-cores, --no-print-cores (default: off)" << std::endl;
out << "Print each found core" << std::endl << std::endl;

out << "--print-stats, --no-print-stats (default: on)" << std::endl;
out << "Print stats after solving" << std::endl << std::endl;

out << "--print-hs (default: 0)" << std::endl;
out << "int: {0,1,2}" << std::endl;
out << "Print hitting sets (0=none 1=optimal 2=all)" << std::endl << std::endl;

out << "--print-solutions, --no-print-solutions (default: off)" << std::endl;
out << "Print a solution each time the upper bound is improved" << std::endl << std::endl;

out << "--print-bounds, --no-print-bounds (default: on)" << std::endl;
out << "Print upper and lower bounds when they are improved" << std::endl << std::endl;

out << "--stream-precision (default: 15)" << std::endl;
out << "int: [1 .. INT_MAX]" << std::endl;
out << "Sets output stream precision for floating-point values" << std::endl << std::endl;

out << "--verb (default: 1)" << std::endl;
out << "int: [0 .. 3]" << std::endl;
out << "Set LMHS verbosity level" << std::endl << std::endl;

out << "--sat-verb (default: 0)" << std::endl;
out << "int: [0 .. 3]" << std::endl;
out << "Set Minisat verbosity level" << std::endl << std::endl;

out << "--mip-verb (default: 0)" << std::endl;
out << "int: [0 .. 2]" << std::endl;
out << "Set CPLEX verbosity level" << std::endl << std::endl;
